// ==UserScript==
// @name         b站直播间房管辅助直播 bilibili 哔哩哔哩
// @namespace    http://tampermonkey.net/
// @version      0.8
// @description  如有任何问题、意见或需求，可以直接在greasyfork反馈
// @author       You
// @match        *://live.bilibili.com/*
// @exclude      *://live.bilibili.com/p/*
// @grant        none
// ==/UserScript==

(function() {


    function zfill(num, n) {
        return (Array(n).join(0) + num).slice(-n);
    }
    class BasicAction{
        static fontButtonOver(){this.style.color = '#23ade5'}
        static fontButtonOut(){this.style.color = '#333'}
        
    }
    class FileUtils{
        static saveFile(filename,data){
            var urlObject = window.URL 
            var export_blob = new Blob(['\ufeff'+data],{type: 'text/csv,charset=UTF-8'});
            var save_link = document.createElement('a')
            save_link.href = urlObject.createObjectURL(export_blob);
            save_link.download = filename;
            save_link.click()
        } 
    }
    
    class Ajax{
        static post(url,data={},head={},callback=()=>{},credentials=true){
            const xhr = new XMLHttpRequest()
            xhr.open('POST',url)
            let urlData = new Array()
            for(let d in data){urlData.push(d+'='+data[d])}
            const urlParams = urlData.join('&')

            for(let h in head){xhr.setRequestHeader(h,head[h])}
            xhr.withCredentials = credentials
            xhr.send(urlParams)
            xhr.onreadystatechange = function(){
                callback(xhr)
            }
        }
    }
    class Dialog{
        static wholeScreen(child,height= '200px',width='200px',top='0px',left='0px'){
            const background = document.createElement('div')
            background.style = 'top:0px;left:0px;z-index:9999;position: fixed; background-color: rgba(0, 0, 0, 0.5); display: flex; flex-flow: column nowrap; justify-content: start; align-items: center; height: 100%; width: 100%;'
            background.onclick = function(){
                this.parentElement.removeChild(this)
            }
            let dialog = child
            if(!child){
                dialog = document.createElement('div')                        
                dialog.style.backgroundColor = 'white'
                dialog.style.borderRadius = '5px'
                dialog.style.height = height
                dialog.style.width = width           
                dialog.style.top = top
                dialog.style.left = left
            }    


            
            dialog.onclick = function (e){
                e.stopPropagation()
            }
            background.appendChild(dialog)
            document.body.appendChild(background)
            return {background,dialog}
        }
    }
    class AdminConsole{
        constructor(){
            this.readSettings.call(this)
            this.injectStyle()
            // this.initMenu()
            this.initConsole()
            this.initDanmaku()
        }
        readSettings (){
            const defaultSetting = {
                hour:'1',
                isShowShortcutBlock:true,
                danmakuWidth:302
            }
            this.settings = JSON.parse(localStorage.getItem('mana-settings')) || {}
            for(let setting in defaultSetting){
                if(!(setting in this.settings)){
                    this.settings[setting] = defaultSetting[setting]
                }
            }
            this.defaultSetting = defaultSetting
        }
        saveSettings(){
            localStorage.setItem('mana-settings',JSON.stringify(this.settings))
        }
        injectStyle(){
            let style = ''
            style += '.mana-fontbutton { cursor: pointer; margin-left: 3px; color: #333; } .mana-fontbutton:hover{ color: #23ade5; }'
            style += '.mana-logbox { top: 200px; position: relative; display: flex; flex-flow: column nowrap; justify-content: start; align-items: center; padding: 20px 20px 20px 20px; background-color: white; border-radius: 5px; overflow: auto; width: 300px; height: 600px; font-size: 12px; }'
            style += '.mana-logline{ border-bottom: 1px solid #e5e5e5; margin: 3px 0px 3px 0px; }'
            style += '.mana-menu-font{display: inline-block; white-space: nowrap;font-size: 12px;line-height: 19px;margin: 0 0 8px;color: #333; } .mana-menu-font:hover{ color: #23ade5; }'
            style += '.mana-setting-box { position: relative; top: 200px; background-color: white; min-width: 200px; display: flex; flex-flow: column nowrap; justify-content: start; align-items: flex-start; padding: 20px; border-radius: 5px; }'
            style += '.mana-setting-line{ vertical-align: middle; margin: 10px 0 10px 0; }'
            style += '.mana-setting-line > input[type=checkbox]{ display: inline-block; vertical-align: middle; }'
            style += '.mana-display-none{ display: none; }'
            style += '.mana-shortcut-block{ margin-right: 3px; }'
            
            
            const styleDOM = document.createElement('style')
            styleDOM.innerHTML = style            
            styleDOM.setAttribute('mana-style','')
            document.body.appendChild(styleDOM)
        }
        initDanmaku(){
            const danmaku = document.getElementById('aside-area-vm')
            const appBody = document.getElementsByClassName('app-body')[0]
            const player = document.getElementsByClassName('player-ctnr')[0]
            if(danmaku && appBody && player){
                if(this.settings.danmakuWidth != this.defaultSetting.danmakuWidth){
                    this.setDanmakuWidth(this.settings.danmakuWidth)
                }
                return
            }
            requestAnimationFrame(this.initDanmaku)
        }
        initMenu(){
            const injectAdmin = () => {
                const container = document.getElementsByClassName('upper-right-ctnr')[0]
                if(container && container.childNodes){
                    if(container.childNodes[0].nodeName=='#comment'&& container.childNodes[1].nodeName == 'DIV'){
                        const cons = document.createElement('div')
                        cons.style.color = '#999'
                        cons.className = 'right-action-ctnr live-skin-normal-a-text pointer dp-i-block primary btn p-relative mana-mana'
                        cons.innerHTML = '<i class="icon-font icon-set-up v-middle"></i> <span data-v-f650ac18="" class="action-text v-middle dp-i-block">管理</span> <div class="drop-ctnr p-absolute" style="display: none"> <div class="common-popup-wrap arrow-top drop-bubble-ctnr"> <div  class="admin-drop-ctnr"> </div> </div> </div>'
                        container.replaceChild(cons,container.childNodes[0])
                        cons.onmouseover = function(){
                            this.style.color = '#23ade5'
                            this.children[2].style.display = 'block'
                        }
                        cons.onmouseout = function(){
                            cons.style.color = '#999'
                            this.children[2].style.display = 'none'
                        }
                        return
                    }else{
                        if(container.childNodes[0].nodeName=='DIV'){
                            return
                        }
                    }
                }
                requestAnimationFrame(injectAdmin)
            }
            injectAdmin()
        }

        initConsole(){
            this.initMenu()
            const selections = ['房管辅助设置','禁言记录']
            const selectionOnclick = {
                '禁言记录':this.openLog,
                '房管辅助设置':this.openMenu
            }
            const injectMenu = () =>{
                const menu = document.getElementsByClassName('admin-drop-ctnr')[0]
                if(menu){
                    for(let selection of selections){
                        const button = document.createElement('span')
                        button.className = 'drop-menu-item ts-dot-4 mana-menu-font'
                        button.innerText = selection
                        if(selection in selectionOnclick){
                            button.onclick = selectionOnclick[selection]
                        }
                        menu.appendChild(button)

                    }
                    return
                }
                requestAnimationFrame(injectMenu)
            }
            injectMenu()
        }
        setDanmakuWidth = (width)=>{
            const currentWidth =  document.getElementById('aside-area-vm').offsetWidth
            document.getElementById('aside-area-vm').style.width = width + 'px'
            const appBody = document.getElementsByClassName('app-body')[0]
            if(appBody){
                const targetWidth = Number(appBody.offsetWidth) + Number(width) - Number(currentWidth)
                appBody.style.width = targetWidth.toString() + 'px'
                appBody.style.maxWidth = targetWidth.toString() + 'px'
            }
            const player = document.getElementsByClassName('player-ctnr')[0]
            if(player){
                player.style.width = `calc(100% - ${width}px - 12px)`
            }

        }
        openMenu=()=>{
            const menus = [
                ['默认禁言时间','input', this.settings.hour],
                ['显示快捷禁言按钮','checkbox',this.settings.isShowShortcutBlock],
                ['弹幕栏宽度','DOM']
            ]
            const onchangeFunction = {
                '默认禁言时间': (e) => {
                    const hour = e.target.value.match(/\d*/)[0] || '1'
                    this.settings.hour = hour
                    this.saveSettings()
                },
                '显示快捷禁言按钮':(e)=>{
                    const isShowShortcutBlock = e.target.checked
                    this.settings.isShowShortcutBlock = isShowShortcutBlock
                    this.saveSettings()
                    if(isShowShortcutBlock){
                        const danmakus = document.getElementsByClassName('mana-shortcut-block')
                        for(let danmaku of danmakus){
                            danmaku.classList.remove('mana-display-none')
                        }
                    }else{
                        const danmakus = document.getElementsByClassName('mana-shortcut-block')
                        for(let danmaku of danmakus){
                            danmaku.classList.add('mana-display-none')
                        }
                    }
                },
                '弹幕栏宽度':(e)=>{
                    const width = e.target.value.match(/\d*/)[0] || this.settings.danmakuWidth
                    this.settings.danmakuWidth = width
                    this.saveSettings()
                    this.setDanmakuWidth(width)
                }
            }

            const DOMFunction = {
                '弹幕栏宽度':(name)=>{
                    const line = document.createElement('div')
                    line.className = 'mana-setting-line'
                    const title = document.createElement('span')
                    title.className = 'mana-setting-title'
                    title.innerText = name+' : '
                    
                    const input = document.createElement('input')
                    input.value = this.settings.danmakuWidth
                    input.onchange = onchangeFunction[name]

                    const button = document.createElement('span')
                    button.innerText = '恢复默认'
                    button.className = 'mana-fontbutton'
                    button.onclick = (e) => {
                        e.target.parentElement.children[1].value = this.defaultSetting.danmakuWidth
                        e.target.parentElement.children[1].onchange({target:e.target.parentElement.children[1]})
                    }
                    
                    line.appendChild(title)
                    line.appendChild(input)
                    line.appendChild(button)

                    return line
                }
            }

            let box = document.createElement('div')
            box.className = 'mana-setting-box'
            for(let menu of  menus){
                if(menu[1] === 'DOM'){
                    box.append(DOMFunction[menu[0]](menu[0]))
                    continue
                }
                const line = document.createElement('div')
                line.className = 'mana-setting-line'
                const title = document.createElement('span')
                title.className = 'mana-setting-title'
                title.innerText = menu[0]+' : '
                let value = ''
                switch(menu[1]){
                    case 'input':
                        value = document.createElement('input')
                        if(menu.length >= 3){
                            value.value = menu[2]
                        }
                        value.className = 'mana-setting-input'
                        if(menu[0] in onchangeFunction){
                            value.onchange = onchangeFunction[menu[0]]
                        }
                        break
                    case 'checkbox':
                        value = document.createElement('input')
                        value.type = 'checkbox'
                        if(menu.length >= 3){
                            value.checked = menu[2]
                        }
                        value.className = 'mana-setting-checkbox'
                        if(menu[0] in onchangeFunction){
                            value.onchange = onchangeFunction[menu[0]]
                        }
                        break                        
                    default:

                }
                line.appendChild(title)
                line.appendChild(value)
                box.appendChild(line)
            }
            const d = Dialog.wholeScreen(box)

            
        }
        openLog = () => {
            let logFile = new Array()
            for(let key in localStorage){
                if(key.startsWith('blockLog-')){
                    logFile.push(key)
                }
            }
            logFile.sort()
            if(logFile.length > 0){
                let box = document.createElement('div')
                box.className = 'mana-logbox'
                for(let file of logFile){
                    const line = document.createElement('div')
                    const title = document.createElement('span')
                    title.innerText = file
                    line.setAttribute('log',file)
                    line.className = 'mana-logline'
                    title.style.minWidth = '200px'
                    title.style.display = 'inline-block'
                    line.appendChild(title)

                    const del = document.createElement('span')
                    del.innerText = '删除'
                    del.onclick = this.deleteLog
                    del.className = 'mana-fontbutton' 
                                 
                    
                    const dowl = document.createElement('span') 
                    dowl.innerText = '下载'
                    dowl.onclick = this.downloadLog
                    dowl.className = 'mana-fontbutton'

                    line.appendChild(del)
                    line.appendChild(dowl)
                    box.appendChild(line)
                    
                }
                const d = Dialog.wholeScreen(box)
            }
        }
        downloadLog(e){
            try{
                const logName = e.target.parentElement.getAttribute('log')
                const log = localStorage.getItem(logName)
                FileUtils.saveFile(logName+'.csv',log)
            }catch(e){console.log('导出日志异常')}
        }
        deleteLog(e){
            try{
                const logName = e.target.parentElement.getAttribute('log')
                if(confirm(`是否要删除日志: ${logName} ?`)){
                    localStorage.removeItem(logName)
                    const container = e.target.parentElement.parentElement
                    for(let line of container.children){
                        if(line.getAttribute('log') === logName){
                            container.removeChild(line)
                        }
                    }
                }

            }catch(e){console.log('删除日志异常')}
        }

    }
    
    class Blocker{
        constructor(adminConsole){
            this.adminConsole = adminConsole
            this.bindMutation()
        }
        bindMutation(){
            const observation = (mutations,observer) =>{
                for(let mutation of mutations){
                    if(mutation.addedNodes.length > 0){
                        for(let node of mutation.addedNodes){
                            if(node.hasAttribute('data-uid')){
                                const deleteButton = document.createElement('span')
                                deleteButton.innerText = '禁言'
                                deleteButton.className = 'v-middle mana-shortcut-block'
                                if(!this.adminConsole.settings.isShowShortcutBlock){deleteButton.className += ' mana-display-none'}
                                deleteButton.onclick = this.addBlockUser
                                deleteButton.style = 'color:#23ade5;cursor:pointer;line-height:20px'
                                node.insertBefore(deleteButton,node.children[0])

                            }
                        }
                    }
                }
            }
            this.chatList =  document.getElementById('chat-items')
            const config = {childList:true}
            const observer = new MutationObserver(observation)
            observer.observe(this.chatList,config)
        }
        removeBlockUser  (dom,data,logTitle,uid,uname)  {
            const head = {
                'accept': 'application/json, text/plain, */*',
                'content-type': 'application/x-www-form-urlencoded'
            }
            Ajax.post('//api.live.bilibili.com/banned_service/v1/Silent/del_room_block_user',data,head,(xhr)=>{
                        if(xhr.readyState == 4 && xhr.status == 200 ){
                            const res = JSON.parse(xhr.responseText)
                            if(res.code == 0){
                                let log = window.localStorage.getItem(logTitle) || ''
                                const date = new Date()
                                log += `${date.getHours()}:${date.getMinutes()}:${date.getSeconds()},,${uid},${uname},撤销禁言\n`                                        
                                window.localStorage.setItem(logTitle,log)

                                dom.innerText = '禁言'
                                dom.onclick = this.addBlockUser
                            }
                        }
                    })
        }
        addBlockUser = (e) =>{
            const container = e.target.parentElement
            const uid = container.getAttribute('data-uid')
            const uname = container.getAttribute('data-uname')
            const danmaku = container.getAttribute('data-danmaku')
            const date = new Date()
            const block_uid = uid || '1'
            const logTitle = `blockLog-${date.getFullYear()}-${zfill(date.getMonth()+1,2)}-${zfill(date.getDate(),2)}`
            
            const cookie = new WebCookie()
            const data = {
                roomid:cookie.roomid || '1',
                block_uid,
                hour:this.adminConsole.settings.hour,
                csrf_token: cookie.bili_jct || '1',
                csrf: cookie.bili_jct || '1',
                visit_id:""
            }
            const head = {
                'accept': 'application/json, text/plain, */*',
                'content-type': 'application/x-www-form-urlencoded'
            }
            Ajax.post('//api.live.bilibili.com/banned_service/v2/Silent/add_block_user',data,head,(xhr)=>{
                if(xhr.readyState == 4 && xhr.status == 200 ){
                    const res = JSON.parse(xhr.responseText)
                    if(res.code == 0){
                        const id = res.data.id
                        let log = window.localStorage.getItem(logTitle) || ''
                        log += `${zfill(date.getHours(),2)}:${zfill(date.getMinutes(),2)}:${zfill(date.getSeconds(),2)},${data.hour},${uid},${uname},${danmaku}\n`
                        window.localStorage.setItem(logTitle,log)
                        const button = container.children[0]
                        button.innerText = '撤销'
                        const removedata = {
                            id,
                            roomid:cookie.roomid || '1',
                            csrf_token: cookie.bili_jct || '1',
                            csrf: cookie.bili_jct || '1',
                            visit_id:""
                        }
                        button.onclick = () =>{
                            this.removeBlockUser.call(this,button,removedata,logTitle,uid,uname)
                        }
                    }
                }
            })
        }
    }

    class WebCookie{
        constructor(){
            const cookies = {}
            for(let cookie of document.cookie.split(';')){
                const [k,v] = cookie.trim().split('=')
                cookies[k] = v
            }
            cookies ['roomid'] = document.location.pathname.substr(1).split('?')[0]
            return cookies
        }
    }
    function doAdmin(){
        const info = document.getElementsByClassName('room-info-upper-row')[0].__vue__ || false
        if(info && info.isAdmin){
            const adminConsole = new AdminConsole()
            const blocker = new Blocker(adminConsole)
        }
    }

    function init(){
        const container =  document.getElementsByClassName('upper-right-ctnr')[0]
        if(container){
            function observation(mutations,observer){
                const info = document.getElementsByClassName('room-info-upper-row')[0].__vue__
                console.log(mutations)
                for(let mutation of mutations){
                    if(info.isAdmin){
                        if(!mutation.addedNodes[0]||!mutation.addedNodes[0].className.indexOf('mana-mana') < 0){
                            doAdmin()
                            break
                        }
                    }
                }
            }
            const config = {childList:true}
            const observer = new MutationObserver(observation)
            observer.observe(container,config)
            doAdmin()

        }else{
            requestAnimationFrame(init)
        }
    }

    init()
    doAdmin()
})();
